<script>
    import axios from 'axios'
    import { useRoute } from 'vue-router'
    import { checkJWT, getJWTData } from '../utils'

    export default {
        data() {
            return {
                recipe: null,
                ingredients: null,
                analysis: null,
                JWTData: null
            }
        },
        methods: {
            async getAllIngredients() {
                const token = sessionStorage.getItem( 'token' )

                if ( token === null ) {
                    redirectToLogin()
                }

                const request = await axios.get( 'https://challenge-calories-api.herokuapp.com/ingredients', {
                    headers: {
                        'Authorization': `Bearer ${token}`,
                        'Access-Control-Allow-Origin': '*',
                        'Accept': 'application/json',
                        'Content-Type': 'application/json'
                    }
                } )
                .catch( error => {
                    console.log('error')
                    console.log(error)
                    // redirectToLogin()
                } )

                if ( request?.data?.ingredients ) {
                    this.ingredients = request.data.ingredients

                    this.recipe.ingredients.map( ( item, index ) => {
                        this.recipe.ingredients[index] = { ...this.recipe.ingredients[index], ...this.getIngredientById( item.id ) }
                    } )
                }
            },
            getIngredientById( id ) {
                if ( this.ingredients ) {
                    return this.ingredients.find( item => item.id == id )
                }
            }
        },
        async beforeMount() {
            const token = sessionStorage.getItem( 'token' )
            const route = useRoute()
            let recipeId = route.params.recipeId

            let request = await axios.get( 'https://challenge-calories-api.herokuapp.com/recipes/' + recipeId, {
                headers: {
                    'Authorization': `Bearer ${token}`,
                    'Access-Control-Allow-Origin': '*',
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                }
            } )
            .catch( error => {
                console.log('error')
                console.log(error)
                checkJWT( error )
            } )

            console.log(request)

            if ( request?.data?.recipe ) {
                this.recipe = request.data.recipe
                recipeId = request.data.recipe.id
                this.getAllIngredients()
            }


            // Analyse
            if ( recipeId ) {
                request = await axios.get( 'https://challenge-calories-api.herokuapp.com/recipes/' + recipeId + '/analyse', {
                    headers: {
                        'Authorization': `Bearer ${token}`,
                        'Access-Control-Allow-Origin': '*',
                        'Accept': 'application/json',
                        'Content-Type': 'application/json'
                    }
                } )
                .catch( error => {
                    console.log('error')
                    console.log(error)
                    checkJWT( error )
                } )

                if ( request?.data ) {
                    this.analysis = request.data
                }
            }

            this.JWTData = getJWTData()

            console.log(this.JWTData, this.recipe)
        }
    }
</script>

<template>
    <div v-if="recipe && ingredients !== null" class="grid grid-cols-12">
        <div class="col-span-2"></div>
        <div class="col-span-full m:col-span-8 flex flex-col gap-xl">
            <h1>{{ recipe.name }}</h1>
            <div v-if="this.analysis" class="p-l border rounded">
                <ul>
                    <li>Total calories: {{ this.analysis.total_calories }}</li>
                    <li>Total carbohydrates: {{ this.analysis.total_carbohydrates }}</li>
                    <li>Total lipids: {{ this.analysis.total_lipids }}</li>
                    <li>Total proteins: {{ this.analysis.total_proteins }}</li>
                </ul>
            </div>
            <p>{{ recipe.description }}</p>
            <ul>
                <li v-for="item in recipe.ingredients">{{ item.name }} <span class="opacity-60">({{ item.quantity }}{{ item.unit }})</span></li>
            </ul>
            <ul class="flex flex-col gap-l">
                <li v-for="(item, index) in recipe.steps">
                    <p class="ts-h3 mb-m">Step {{ index + 1 }}</p>
                    <p>{{ item }}</p>
                </li>
            </ul>
            <RouterLink v-if="JWTData && JWTData.id == recipe.user_id" :to="{ name: 'recipe-update', params: { recipeId: recipe.id }}" class="mt-xl">Edit</RouterLink>
        </div>
    </div>
</template>